



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>C++ Prime：指针</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">C++ Prime：指针</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-10 22:19:37 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>　　指针与引用的区别：1、指针本身就是一个对象，允许对指针赋值和拷贝，而且在指针的生命周期内它可以先后指向几个不同的对象；其二：指针无需在定义时赋值。指针在块作用域内定义如果没有被初始化，也将拥有一个不确定的值。</p>
<p>　　</p>
<p>空指针：</p>
<p>　　得到空指针最直接的办法就是用字面值nullptr来初始化指针，这是C+ 11新标准刚刚引入的一种方法。nullptr是一种特殊类型的字面值，可以被转换成任意其他的指针类型。另外一种方法就是通过指针初始化为字面值0来生成空指针。</p>
<p>　　有时候还会用到一个名为NULL的预处理变量来给指针赋值，这个变量在头文件cstdlib中定义，它的值就是0.</p>
<p>void* 指针：</p>
<p>　　void* 是一种特殊的指针类型，可以用于存放任意对象的地址。一个void* 指针存放着一个地址，这一点和其他指针类似。不同的是，我们对该地址中到底是个什么类型的对象并不了解：</p>
<div>
<pre class="prettyprint linenums">double obj = 3.14, *pd = &amp;obj;<br />
void *pv = &amp;obj;    // void*能存放任意类型对象的地址，obj可以是任意类型的对象<br />
pv = pd;    // pv可以存放任意类型的指针</pre>
</div>
<p>　　利用void*指针能做的事也比较有限：拿它和其他的指针比较、作为函数的输入或输出，或者赋给另外一个void*指针。不能直接操作void*指针所指的对象，因为我们并不知道这个对象到底是什么类型，也就不能确定能在这个对象上做哪些操作。</p>
<p>指向指针的引用：</p>
<p>　　引用本身不是一个对象，因此不能定义指向引用的指针，但指针是对象，所以存在对指针的引用：</p>
<div>
<pre class="prettyprint linenums">int i = ;<br />
int *p;    // p是一个int指针<br />
int *&amp;r = p;    // r是一个对指针p的引用

r = &amp;i;    // r引用了一个指针，因此给r赋值&amp;i就是令p指向i<br />
*r = ;    // 解引用r得到i，也就是p指向的对象，将i的值改为0</pre>
</div>
<p>　　要理解r的类型到底是什么，最简单的就是从右到左阅读r的定义。离变量名最近的符号对变量的类型有最直接的影响，因此r是一个引用。声明符的其余部分用以确定r引用的类型是什么，此例中的符号*说明r引用的是一个指针。最后声明的基本数据类型部分指出r引用的是一个int的指针。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq11g6qg.html">C&num;实现微信开发前奏</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq154k29.html">BZOJ 4581&colon; &lbrack;Usaco2016 Open&rsqb;Field Reduction</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pgvk49.html">day--6&lowbar;python常用模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96l7z39.html">floyd算法小结</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kl5n6q.html">Ubuntu 开机进入命令行模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8ordv18.html">Jedis工具类</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8evm2x9.html">搭建Java环境JDK，和运行环境JRE</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlg47x9.html">maven运行javaWeb项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k3pvjq.html">Android Studio 想说爱你不容易</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmpm269.html">python url编码</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnr0rv8.html">jQuery技术内幕预览版&period;pdf2</a>
		</li>
						<li><a href="https://www.batexi.com/a/9500mv68.html">小强的HTML5移动开发之路（50）&mdash;&mdash;jquerymobile页面初始化过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdky709.html">Linux NGINX部署</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw0kvy8.html">Oracle Oracle数据库 迁移到 SQL Server上</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2gol19.html">POJ2236&lpar;KB5-A&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvx362q.html">05引用类型以及特殊引用类型string</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pwl2eq.html">学习笔记：状态压缩DP</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnnp23jq.html">CI框架浅析（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qndj7j38.html">点击按钮添加一行&comma;和本行的删除功能&comma;序号变动&comma;name属性更改</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r4m6x48.html">ClipboardJS复制粘贴插件的使用</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8k16kz39.html">PHP&amp;amp&semi;nbsp&semi;支持的协议／封装协议列表</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e16ryk9.html">HTML 5 全局属性</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pj62z49.html">Java GetAndPost</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdp3nr8.html">&lbrack;Twisted&rsqb; deferred</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmddk19.html">Eclipse反编译工具Jad及插件</a>
			</li>
						<li><a href="https://www.batexi.com/a/96o2nw39.html">v880 debug</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k16ep39.html">pushState与replaceState区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e16g5x9.html">Java：对象的序列化</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xr4nn9.html">制作font-icon有感</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xr4kr9.html">Linux下安装gcc 、g&plus;&plus; 、gfortran编译器</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
